﻿
Imports System.Linq
Public Class Class1
    Public Structure BaseDataSource
        Public Identifier As Integer
        Public Field1 As Double
        Public Field2 As Double
        Public Field3 As Double
        Public Field4 As Double
        Public Field5 As Double
        Public Field6 As Double
    End Structure

    Private AllDataSources As IEnumerable(Of BaseDataSource)
    Private SpecificRow As BaseDataSource
    Private mIdentifier As Integer

    Public Sub New(ByVal MyIdentifier As Integer, ByVal MyBaseData As IEnumerable(Of BaseDataSource))
        mIdentifier = MyIdentifier
        AllDataSources = MyBaseData
        SpecificRow = MyBaseData.First(Function(p) p.Identifier = MyIdentifier)
    End Sub

    Public ReadOnly Property Identifier() As Integer
        Get
            Return mIdentifier
        End Get
    End Property

    Public ReadOnly Property Result1() As Double
        Get
            Return SpecificRow.Field1 * SpecificRow.Field2
        End Get
    End Property

    Public ReadOnly Property Result2() As Double
        Get
            Return Result1 * SpecificRow.Field3
        End Get
    End Property

    Public ReadOnly Property Result3() As Double
        Get
            Return Result2 ^ SpecificRow.Field4
        End Get
    End Property

    Public ReadOnly Property Result4() As Double
        Get
            Return Result1 * Result2 * Result3
        End Get
    End Property

    Public ReadOnly Property Result5() As Double
        Get
            Dim ConditionalRows = From a In AllDataSources Where a.Field5 > Result4 Select a.Field5
            If ConditionalRows.Sum > 0 Then
                Return ConditionalRows.Sum
            Else
                Return 0
            End If
        End Get
    End Property

    Public ReadOnly Property Result6() As Double
        Get
            If Result5 > 100 Then
                Return Result5
            Else
                Return 0
            End If
        End Get
    End Property

End Class
